      subroutine nonlin_b(imodel, per, v30, 
     :   bnl, b1_per, b2_per, v1_per, v2_per)
     
* Input parameters: imodel, per, v30     
      
* Dates: 08/10/05 - Corrected error for pgv (per < 0.0)  
*        03/18/07 - Added values for T = 5.0, 7.5, 10.0 sec.

      
      real  Tcs(30), b1(30), b2(30)
 	
      data Tcs/0.01, 0.02, 0.03, 0.04, 0.05,
     :         0.06,0.075, 0.09, 0.10, 0.12,
     :         0.15, 0.17, 0.20, 0.24, 0.30,
     :         0.36, 0.40, 0.46, 0.50, 0.60,
     :         0.75, 0.85, 1.00, 1.50, 2.00,
     :         3.00, 4.00, 5.00,
     :         7.50, 10.0/

      data b1/-0.64,-0.63,-0.62,-0.61,-0.64,
     :        -0.64,-0.64,-0.64,-0.60,-0.56,
     :        -0.53,-0.53,-0.52,-0.52,-0.52,
     :        -0.51,-0.51,-0.50,-0.50,-0.49,
     :        -0.47,-0.46,-0.44,-0.40,-0.38,
     :        -0.34,-0.31,-0.291,  ! replace old value of -0.30 for T = 5 
     :        -0.247,-0.215/                                  
     
      data b2/-0.14,-0.12,-0.11,-0.11,-0.11,
     :        -0.11,-0.11,-0.12,-0.13,-0.14,
     :        -0.18,-0.19,-0.19,-0.16,-0.14,
     :        -0.11,-0.10,-0.08,-0.06,-0.03,
     :        -0.00,-0.00,-0.00,-0.00,-0.00,
     :        -0.00,-0.00,-0.00,
     :        -0.00,-0.00/
     
      n_cs = 30

      if (per .lt. 0.0) then  ! pgv
        per_interp = 0.5
      else if (per .eq. 0.0) then ! pga
        per_interp = 0.0
      else
        per_interp = per
      end if
      
      bv = 300.0 ! Choi & Stewart, Table 3, not same as BJF bv


      call lin_interp(tcs, b1,  n_cs, ics, per_interp, dum) ! only want index


      if (imodel .eq. 1) then ! Choi and Stewart model

        v1cs = 180.0
        v2cs = 520.0
        vacs = 760.0
      
        v1_per = v1cs
        v2_per = v2cs
        
         if (v30 .lt. v1cs) then
           bnl = b1(ics)
         else if (v30 .ge. v1cs .and. 
     :            v30 .lt. bv)  then
           bnl = b2(ics) + 
     :                (b1(ics)-b2(ics))*((v30-bv)/(v1cs-bv))**2
         else if (v30 .ge. bv .and. 
     :            v30 .lt. v2cs)  then
           bnl = b2(ics)
         else if (v30 .ge. v2cs .and. 
     :            v30 .lt. vacs)  then
           bnl = b2(ics) - (v30-v2cs)*(b2(ics)/240.0)
         else
           bnl = 0.0
         end if

      else if (imodel .eq. 2) then ! Atkinson model

        v1gma = 170.0
        vagma = 760.0
        v1_per = v1gma
        v2_per = 0.0
       
         if (v30 .lt. vagma) then
           bnl = b1(ics) * 
     :          alog(v30/vagma)/alog(v1gma/vagma)
         else
           bnl = 0.0
         end if

      else if (imodel .eq. 3) then ! Dave's model 1; used for BA NGA equations

        v1dmb = 180.0
        v2dmb = bv
        vadmb = 760.0
        v1_per = v1dmb
        v2_per = v2dmb
      
         if (v30 .lt. v1dmb) then
           bnl = b1(ics)
         else if (v30 .ge. v1dmb .and. 
     :            v30 .lt. v2dmb)  then
           bnl = (b1(ics)-b2(ics)) * 
     :         alog(v30/v2dmb)/alog(v1dmb/v2dmb) + b2(ics) 
         else if (v30 .ge. v2dmb .and. 
     :            v30 .lt. vadmb)  then
           bnl = b2(ics) * 
     :         alog(v30/vadmb)/alog(v2dmb/vadmb)            
         else
           bnl = 0.0
         end if

      else if (imodel .eq. 4) then ! Dave's model 2
                                   ! (slope increases for small v30)

        v1dmb = 180.0
        v2dmb = bv
        vadmb = 760.0
        v1_per = v1dmb
        v2_per = v2dmb
      
         if (v30 .lt. v1dmb) then
           bnl = b1(ics) * 
     :          alog(v30/vadmb)/alog(v1dmb/vadmb)
         else if (v30 .ge. v1dmb .and. 
     :            v30 .lt. v2dmb)  then
           bnl = (b1(ics)-b2(ics)) * 
     :         alog(v30/v2dmb)/alog(v1dmb/v2dmb) + b2(ics) 
         else if (v30 .ge. v2dmb .and. 
     :            v30 .lt. vadmb)  then
           bnl = b2(ics) * 
     :         alog(v30/vadmb)/alog(v2dmb/vadmb)            
         else
           bnl = 0.0
         end if

      else
 
        print *,' imodel ',imodel,' not valid; quitting!'
        stop
 
      end if
      
      b1_per = b1(ics)
      b2_per = b2(ics)
      
      return
      end    
  